
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "srf.h"

extern void	Error();

typedef struct {
		int	i_e,n;
		char	*T;
		double	a;
	} LD;

static int	Compare(ld1,ld2)
LD		*ld1,*ld2;
{
	int	i_e=ld1->i_e-ld2->i_e;

	return i_e?i_e:(ld1->a>ld2->a)?1:(ld1->a<ld2->a)?-1:0;
}

#define ERROR(msg)	{ \
	(void)fprintf(stderr,"%s : ",path); Error(msg); \
}

static FILE	*Open(path)
char		*path;
{
	FILE	*file;

	if ((file=fopen(path,"r"))!=NULL) ERROR("file already exists.")
	if ((file=fopen(path,"w"))==NULL) ERROR("can not create file.")

	return file;
}

static void	Print(directory,N,Q,ld,i_e,file)
char		*directory,**Q;
int		N,i_e;
LD		*ld;
FILE		*file;
{
	for (; --N>=0; ld++)
	    if (ld->i_e==i_e)
		(void)fprintf(file,"%s/%s\t%s\n",directory,Q[ld->n],ld->T);
}

#define STR_LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	*O,*D,**Q,path[STR_LEN],line[STR_LEN],T[STR_LEN],
		*nmfld="no memory for log data.";
	int	N,n,i_e;
	LD	*ld;
	FILE	*file;
	double	a;

	if (argc!=2 && argc!=5)
	    Error("usage : dit_tbl directory {d.tbl i.tbl t.tbl}");

	SearchRawFiles(argv[1],&O,&D,&N,&Q);

	if ((ld=(LD *)malloc((size_t)N*sizeof(LD)))==NULL) Error(nmfld);

	for (n=0; n<N; n++) ld[n].i_e=2;

	(void)sprintf(path,"%s/%s",argv[1],O);
	if ((file=fopen(path,"r"))==NULL) ERROR("file not found.")

#define ABORT(msg)	{ \
	(void)fputs(line,stderr); ERROR(msg); \
}

	while (fgets(line,STR_LEN,file)!=NULL &&
	       sscanf(line,"%d %s %lf %d",&n,T,&a,&i_e)==4) {
	    if (n<0 || n>=N || i_e<0 || i_e>1) ABORT("bad log data.")
	    if (ld[n].i_e!=2) ABORT("duplicated sequence number.")
	    if (Q[n]==NULL) ABORT("no I0- and/or I-image file.")
	    if ((ld[n].T=strdup(T))==NULL) Error(nmfld);

	    ld[n].i_e=i_e; ld[n].n=n; ld[n].a=a;
	}
	(void)fclose(file);

	qsort(ld,(size_t)N,sizeof(LD),Compare);

	if (argc==2) {
	    (void)printf("%s/%s\t0\n",argv[1],D);
	    (void)putchar('\n');
	    Print(argv[1],N,Q,ld,0,stdout);
	    (void)putchar('\n');
	    Print(argv[1],N,Q,ld,1,stdout);
	}
	else {
	    (void)fprintf(file=Open(argv[2]),"%s/%s\t0\n",argv[1],D);
	    (void)fclose(file);
	    Print(argv[1],N,Q,ld,0,file=Open(argv[3]));
	    (void)fclose(file);
	    Print(argv[1],N,Q,ld,1,file=Open(argv[4]));
	    (void)fclose(file);
	}
	return 0;
}
