
#include <stdio.h>
#include <stdlib.h>

extern void	Error(char *msg);

#define LEN	2048

int	main(int argc,char **argv)
{
	FILE	*in,*out;
	char	str[LEN];
	int	Nr,Nz,t,z,r,Nt=1;
	double	*P,dp,Dr=1.0;

	if (argc!=3 && argc!=4) Error("usage : xp2dp XP.bin {Dr} DP.bin");

	if (argv[1][0]=='-')
	    in=stdin;
	else
	    if ((in=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fgets(str,LEN,in)==NULL ||
	    sscanf(str,"%d %d %d",&Nr,&Nz,&Nt)<2 ||
	    Nr<=0 || Nz<=0 || Nt<=0) Error("bad projection data size.");
	
	if ((P=(double *)malloc(sizeof(double)*Nr))==NULL)
	    Error("memory allocation error.");

	if (argc==4) Dr=atof(argv[2]);

	if (argv[argc-1][0]=='-')
	    out=stdout;
	else
	    if ((out=fopen(argv[argc-1],"wb"))==NULL) Error("file not open.");

	(void)fprintf(out,"%d\t%d\t%d\n",Nr,Nz,Nt);

	for (t=0; t<Nt; t++)
	for (z=0; z<Nz; z++) {
	    if (fread(P,sizeof(double),Nr,in)!=Nr)
		Error("projection data read error.");

	    for (r=0; r<Nr; r++) {
#ifdef	PRS
#define P0	-P[r]
#else
#define P0	0.0
#endif
		dp=(((r==Nr-1)?P0:P[r+1])-((r==0)?P0:P[r-1]))/2.0/Dr;
		(void)fwrite(&dp,sizeof(double),1,out);
	    }
	}
	if (out!=stdout) (void)fclose(out);
	if (in !=stdin ) (void)fclose(in );

	free(P);

	return 0;
}
