
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

extern void	Error(char *msg);

#define LEN	2048

static void	Store(char *path,int Nx,int Ny,double *P)
{
	FILE	*file;
	char	str[LEN];

	if (*path=='-')
	    file=stdout;
	else
	    if ((file=fopen(path,"wb"))==NULL) {
		(void)sprintf(str,"%s : file not open.",path); Error(str);
	    }

	(void)fprintf(file,"%d\t%d\n",Nx,Ny);
	(void)fwrite(P,sizeof(double),(size_t)Nx*Ny,file);
	if (file!=stdout) (void)fclose(file);
}

int	main(int argc,char **argv)
{
	FILE	*file;
	char	str[LEN];
	int	Nx,Ny,y,z,x,Nz=1;
	double	**P1,**P2,p1,p2,p;

	if (argc!=4) Error("usage : xp2msd XP.bin XP_mean XP_SD.bin");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fgets(str,LEN,file)==NULL ||
	    sscanf(str,"%d %d %d",&Nx,&Ny,&Nz)<2 ||
	    Nx<=0 || Ny<=0 || Nz<=0) Error("bad projection data size.");

	if ((P1=(double **)malloc(sizeof(double *)*Ny))==NULL ||
	    (*P1=(double *)malloc(sizeof(double)*Ny*Nz))==NULL ||
	    (P2=(double **)malloc(sizeof(double *)*Ny))==NULL ||
	    (*P2=(double *)malloc(sizeof(double)*Ny*Nz))==NULL)
	    Error("memory allocation error.");

	for (y=1; y<Ny; y++) {
	    P1[y]=P1[y-1]+Nz; P2[y]=P2[y-1]+Nz;
	}
	for (z=0; z<Nz; z++)
	for (y=0; y<Ny; y++) {
	    p1=p2=0.0;
	    for (x=0; x<Nx; x++) {
		if (fread(&p,sizeof(double),1,file)!=1)
		    Error("projection data read error.");

		p1+=p; p2+=(p*p);
	    }
	    p=P1[y][z]=p1/(double)Nx; P2[y][z]=sqrt(p2/(double)Nx-p*p);
	}
	if (file!=stdin) (void)fclose(file);

	Store(argv[2],Nz,Ny,*P1);
	Store(argv[3],Nz,Ny,*P2);

	free(*P2); free(P2); free(*P1); free(P1);

	return 0;
}
