
#include <stdio.h>
#include <stdlib.h>

extern void	Error(char *msg);

#define LEN	2048

int	main(int argc,char **argv)
{
	FILE	*file;
	char	str[LEN];
	int	Nr,Nz,Nt,z,t,r;
	double	**sum,p,Dr=1.0;

	if (argc!=3 && argc!=4) Error("usage : xp2sp XP_3D.bin {Dr} SP_2D.bin");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fgets(str,LEN,file)==NULL ||
	    sscanf(str,"%d %d %d",&Nr,&Nz,&Nt)!=3 ||
	    Nr<=0 || Nz<=0 || Nt<=0) Error("bad projection data size.");
	
	if ((sum=(double **)malloc(sizeof(double *)*Nz))==NULL ||
	    (*sum=(double *)malloc(sizeof(double)*Nz*Nt))==NULL)
	    Error("memory allocation error.");

	for (z=1; z<Nz; z++) sum[z]=sum[z-1]+Nt;

	if (argc==4)
#ifdef	DPC
	    Dr=atof(argv[2])*atof(argv[2]);
#else
	    Dr=atof(argv[2]);
#endif
	for (t=0; t<Nt; t++)
	for (z=0; z<Nz; z++) {
#ifdef	DPC
/*
	    double	o=0.0;
*/
	    double	o=(double)(Nr+1)/2.0;
#endif
	    double	w=0.0;

	    for (r=0; r<Nr; r++) {
		if (fread(&p,sizeof(double),1,file)!=1)
		    Error("projection data read error.");
#ifdef	DPC
/*
		w+=(o+=p);
*/
		w+=((o-=1.0)*p);
#else
		w+=p;
#endif
	    }
	    sum[z][t]=w*Dr;
	}
	if (file!=stdin) (void)fclose(file);

	if (argv[argc-1][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[argc-1],"wb"))==NULL) Error("file not open.");

	(void)fprintf(file,"%d\t%d\n",Nt,Nz);
	(void)fwrite(*sum,sizeof(double),(size_t)Nz*Nt,file);

	if (file!=stdout) (void)fclose(file);

	free(*sum); free(sum);

	return 0;
}
